<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  
			   creationComplete="creationCompleteHandler(event)" 
			   title="Cadastro de Duplicata Parcela Cobrança"
			  maxWidth="1200" maxHeight="700"  
			   xmlns:visual="br.com.desenv.framework.component.visual.*"   xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
			   
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	
	<fx:Metadata>
		[Event(name="DuplicataParcelaCobrancaIncluidoEvent")]
		[Event(name="DuplicataParcelaCobrancaAtualizadoEvent")]
		[Event(name="DuplicataParcelaCobrancaExcluidoEvent")]
		[Event(name="DuplicataParcelaCobrancaSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.DuplicataParcelaCobranca;
			
			// Alguem passa a objeto para ca
			public var duplicataParcelaCobranca : DuplicataParcelaCobranca = new DuplicataParcelaCobranca();
			

			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
				ignComboBoxFixoOcorrencia.selectedIndex = -1;
				ignTextInputDateData.text = "";
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				
				// Se e um novo cadastro
				if (isNaN(this.duplicataParcelaCobranca.id))
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{
					for(var i:int = 0; i < this.listaOpcaoOcorrencia.length; i++)
					{
						if (this.listaOpcaoOcorrencia.getItemAt(i).codigo == this.duplicataParcelaCobranca.ocorrencia)
						{
							ignComboBoxFixoOcorrencia.selectedIndex = i;
							break;
						}
					}

					ignTextInputDateData.text = DateField.dateToString(this.duplicataParcelaCobranca.data, "DD/MM/YYYY"); 

				}
			}
			
			
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (isNaN(duplicataParcelaCobranca.id) == false) 
					{
						duplicataParcelaCobranca.ocorrencia = ignComboBoxFixoOcorrencia.selectedItem==null?null:ignComboBoxFixoOcorrencia.selectedItem.codigo == ""?null:ignComboBoxFixoOcorrencia.selectedItem.codigo;
						duplicataParcelaCobranca.data = ignTextInputDateData.text == ""?null:DateField.stringToDate(ignTextInputDateData.text, "DD/MM/YYYY");
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("duplicataParcelaCobrancaService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(duplicataParcelaCobranca); 
					// Se e inclusao
					} 
					else 
					{
						duplicataParcelaCobranca.ocorrencia = ignComboBoxFixoOcorrencia.selectedItem==null?null:ignComboBoxFixoOcorrencia.selectedItem.codigo == ""?null:ignComboBoxFixoOcorrencia.selectedItem.codigo;

						duplicataParcelaCobranca.data = ignTextInputDateData.text == ""?null:DateField.stringToDate(ignTextInputDateData.text, "DD/MM/YYYY");

						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("duplicataParcelaCobrancaService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(duplicataParcelaCobranca); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.duplicataParcelaCobranca = event.result as DuplicataParcelaCobranca;
				this.dispatchEvent(new ResultEvent("DuplicataParcelaCobrancaIncluidoEvent",false, true, this.duplicataParcelaCobranca, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.duplicataParcelaCobranca = event.result as DuplicataParcelaCobranca;
				this.dispatchEvent(new Event("DuplicataParcelaCobrancaAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				

			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoDuplicataParcelaCobranca" property="selectedItem" required="true" source="{comboBoxSituacaoDuplicataParcelaCobranca}" trigger="{comboBoxSituacaoDuplicataParcelaCobranca}" triggerEvent="valueCommit"/> -->
		
		<s:ArrayCollection id="listaOpcaoOcorrencia">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="P" valor="Pagamento"/>
			<fx:Object codigo="C" valor="Cobrança"/>
		</s:ArrayCollection>

		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
					
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="720" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Ocorrencia:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoOcorrencia" styleName="labelValidacao" text="{ignComboBoxFixoOcorrencia.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoOcorrencia" obrigatorio="true"  dataProvider="{listaOpcaoOcorrencia}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Data:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoData" styleName="labelValidacao" text="{ignTextInputDateData.errorString}"/>
					<visual:IgnTextInputDate id="ignTextInputDateData" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>



		</mx:GridRow>		
		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>